if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Workplace_Get_By_10_Addresses' ) )
	Drop procedure [dbo].[A_Workplace_Get_By_10_Addresses] 
GO

Create Procedure [dbo].[A_Workplace_Get_By_10_Addresses] 
	@address0	nvarchar (50) = '',
	@address1 	nvarchar (50) = '',
	@address2 	nvarchar (50) = '',
	@address3 	nvarchar (50) = '',
	@address4 	nvarchar (50) = '',
	@address5 	nvarchar (50) = '',
	@address6 	nvarchar (50) = '',
	@address7 	nvarchar (50) = '',
	@address8 	nvarchar (50) = '',
	@address9 	nvarchar (50) = '',
	@address10 	nvarchar (50) = '',
	@type 		int OUTPUT,
	@parentwpt 	uniqueidentifier OUTPUT, 
	@id 		uniqueidentifier OUTPUT, 
	@name 		nvarchar(50) OUTPUT, 
	@address 	nvarchar(50) OUTPUT,
	@haslogic 	bit OUTPUT, 
	@hasfastengine 	bit OUTPUT, 
	@hasdatabase 	bit OUTPUT, 
	@hasextlines 	bit OUTPUT, 
	@lineid 	uniqueidentifier OUTPUT,
	@hasGSM 	bit OUTPUT, 
	@hasintlines 	bit OUTPUT,
	@retvalue 	int OUTPUT
AS
BEGIN
	Declare @cnt int
	Set @retvalue=50102
	Declare @pass nvarchar(50)
	
	Select @cnt=count(*) 
	From A_WorkPlaces 
	Where (Type in (0,1,5)) 
		and ((Address like @address0)
			or (Address like @address1)
			or (Address like @address2)
			or (Address like @address3)
			or (Address like @address4)
			or (Address like @address5)
			or (Address like @address6)
			or (Address like @address7)
			or (Address like @address8)
			or (Address like @address9)
			or (Address like @address10)) 
	        and (hasdatabase=0) 
		and not (Address like '')

	if ( @cnt > 0 )
	begin
		Select @name = name, 
			@address = address, 
			@type=type, 
			@parentwpt=Parentid,@id=[ID], 
			@haslogic=haslogic, 
			@hasfastengine=hasfastengine, 
			@hasdatabase=hasdatabase, 
			@hasextlines=hasextlines,
			@hasGSM=hasGSM, 
			@hasintlines=hasintlines, 
			@lineid=lineid
		From A_WorkPlaces
		Where (Type in (0,1,5)) 
			and ((Address like @address0)
				or (Address like @address1)
				or (Address like @address2)
				or (Address like @address3)
				or (Address like @address4)
				or (Address like @address5)
				or (Address like @address6)
				or (Address like @address7)
				or (Address like @address8)
				or (Address like @address9)
				or (Address like @address10)) 
		        and (hasdatabase=0) 
			and not (Address like '')
	
		Set @retvalue=0
	end
	else
	begin
		Set @retvalue=50102
	end
end
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Workplace_Get_By_Address' ) )
	Drop procedure [dbo].[A_Workplace_Get_By_Address] 
GO


Create Procedure [dbo].[A_Workplace_Get_By_Address] 
	@address nvarchar(50),
	@type int OUTPUT , 
	@parentwpt uniqueidentifier OUTPUT, 
	@id uniqueidentifier OUTPUT, 
	@name nvarchar(50) OUTPUT, 
	@haslogic bit OUTPUT, 
	@hasfastengine bit OUTPUT, 
	@hasdatabase bit OUTPUT, 
	@hasextlines bit OUTPUT,
	@hasGSM bit OUTPUT, 
	@hasintlines bit OUTPUT,
	@retvalue int OUTPUT
As
Begin
	Declare @cnt int
	Set @retvalue=50102
	Declare @pass nvarchar(50)
	
	Select @cnt=count(*) 
	From A_Workplaces 
	Where (Type in (0,1,5)) 
		and (Address like @address)

	if ( @cnt > 0 )
	begin
		Select @name=name, 
			@type=type, 
			@parentwpt=Parentid,
			@id=[ID], 
			@haslogic=haslogic, 
			@hasfastengine=hasfastengine, 
			@hasdatabase=hasdatabase, 
			@hasextlines=hasextlines,
			@hasGSM=hasGSM, 
			@hasintlines=hasintlines
		From A_Workplaces 
		Where (Type in (0,1,5)) 
			and (Address like @address)
		
		Set @retvalue=0
	end
	else
	begin
		Set @retvalue=50102
	end
End
GO



if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Workplace_Get_By_Id' ) )
	Drop procedure [dbo].[A_Workplace_Get_By_Id] 
GO


Create Procedure [dbo].[A_Workplace_Get_By_Id] 
	@id uniqueidentifier, 
	@type int OUTPUT , 
	@parentwpt uniqueidentifier OUTPUT, 
	@address nvarchar(50) OUTPUT, 
	@name nvarchar(50) OUTPUT, 
	@haslogic bit OUTPUT, 
	@hasfastengine bit OUTPUT, 
	@hasdatabase bit OUTPUT, 
	@hasextlines bit OUTPUT,
	@hasGSM bit OUTPUT, 
	@hasintlines bit OUTPUT, 
	@lineid uniqueidentifier OUTPUT,
	@retvalue int OUTPUT
As
Begin
	Declare @cnt int
	Set @retvalue=50101
	Declare @pass nvarchar(50)
	
	Select @cnt=count(*) 
	From A_Workplaces
	Where ID = @id

	if ( @cnt > 0 )
	begin
		Select @name=name, 
			@type=type, 
			@parentwpt=Parentid,
			@address=address, 
			@lineid=lineid,
			@haslogic=haslogic, 
			@hasfastengine=hasfastengine, 
			@hasdatabase=hasdatabase, 
			@hasextlines=hasextlines,
			@hasGSM=hasGSM, 
			@hasintlines=hasintlines
		From A_Workplaces
		Where ID = @id
		
		Set @retvalue = 0
	end
	else
	begin
		Set @retvalue = 50101
	end
	
End
GO
