if exists ( Select * FROM sysobjects where id= object_id ( 'dbo.A_Stat_Connection_Start' ) )
	Drop procedure dbo.A_Stat_Connection_Start
GO


Create Procedure dbo.A_Stat_Connection_Start
	
	@id			uniqueidentifier,
	@idchain		uniqueidentifier,
	@connectiontype		int,
	@reasonstart		int,
	@timestart		datetime,
	@timeanswer		datetime,
	@alineid		uniqueidentifier,
	@alinenum		nvarchar ( 8 ),
	@anumberdialed		nvarchar ( 50 ),
	@aoutnumber		nvarchar ( 50 ),
	@astr			nvarchar ( 50 ),
	@auserid		uniqueidentifier,
	@blineid		uniqueidentifier,
	@blinenum		nvarchar ( 8 ),
	@bnumberdialed		nvarchar ( 50 ),
	@boutnumber		nvarchar ( 50 ),
	@bstr			nvarchar ( 50 ),
	@buserid		uniqueidentifier,
	@isrecorded		int,
	@recorddir		nvarchar ( 1000 ),

	@optimizedblevel	int = 0,
	@fromccinput		int = -1
as
begin

	--    Connections_1x1    

	Declare @idprev uniqueidentifier

	--  ?
	Declare @betweenop bit
	Set @betweenop = 0
	if ( exists ( Select Id From A_Users Where Id = @auserid )
	 	and exists ( Select Id From A_Users Where Id = @buserid ) )
		Set @betweenop = 1
	else if ( exists ( Select Id From A_View_ServerIntLinesAll Where Id = @alineid ) 
		and exists ( Select Id From A_View_ServerIntLinesAll Where Id = @blineid ) )
		Set @betweenop = 1

	--  ? -    ,      -        (      )
	Declare @fromcc bit
	if ( @fromccinput >= 0 and @fromccinput <= 1 )
		Set @fromcc = @fromccinput
	else
	  begin
		Set @fromcc = 0
		if exists ( Select TimeStart From A_TaskManager_UserInTask With ( NOLOCK )
				Where ( UserId = @auserid or UserId = @buserid )
				And TimeStopDialog is null --     -     -   
				)	
			Set @fromcc = 1
 	  end

	--   
	Declare @idrecdir int
	set @idrecdir = 0

	if (( @isrecorded > 0 ) and ( @recorddir != '' ))
	begin
		Select @idrecdir = Max ( id ) 
		From A_Stat_RecordDirectories

		Declare @nowrecdir nvarchar ( 1000 )
		Select @nowrecdir = path 
		From A_Stat_RecordDirectories
		Where Id = @idrecdir

		if (( @nowrecdir != @recorddir ) or ( @nowrecdir is null ))
		begin
			Insert into A_Stat_RecordDirectories
			Values ( @recorddir, @timestart )
			
			set @idrecdir = @@identity
		end
	end


	if ( @optimizedblevel < 0 )--( @optimizedblevel = 0 )
	begin
		--   
		Select top 1 @idprev = Id
		From A_Stat_Connections_1x1 With ( NOLOCK )
		Where IdChain = @idchain 
		Order by TimeStart desc

		--    
		if ( @@rowcount > 0 )	
		begin
			Update A_Stat_Connections_1x1
			Set IdNext = @Id
			Where IdChain = @idchain
				And Id = @idprev
		end
	end

	
	--    
	Insert into A_Stat_Connections_1x1
	(
		Id,
		IdChain,
		IdPrev,
		ConnectionType,
		ReasonStart,	
		TimeStart,		
		TimeAnswer,		
		ALineId,	
		ALineNum,
		ANumberDialed,
		AOutNumber,	
		AStr,	
		AUserId,
		BLineId,	
		BLineNum,		
		BNumberDialed,
		BOutNumber,	
		BStr,	
		BUserId,
		IsRecorded,
		IdRecDir,		
		IsBetweenUsers,
		FromCC
	)

	Values

	(
		@id,
		@idchain,
		@idprev,
		@connectiontype,
		@reasonstart,
		@timestart,
		@timeanswer,
		@alineid,
		@alinenum,
		@anumberdialed,
		@aoutnumber,
		@astr,
		@auserid,
		@blineid,
		@blinenum,
		@bnumberdialed,
		@boutnumber,
		@bstr,
		@buserid,
		@isrecorded,
		@idrecdir,		
		@betweenop,
		@fromcc --0
	)
	
end
GO



if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_Connection_Stop' ) )
	Drop procedure dbo.A_Stat_Connection_Stop
GO

Create Procedure dbo.A_Stat_Connection_Stop
	
	@id			uniqueidentifier,
	@reasonstop		int,
	@stopside		int,
	@timestop		datetime,
	@idchain		uniqueidentifier = '00000000-0000-0000-0000-000000000000'

as
begin
	--       Connections_1x1

	if ( @idchain = '00000000-0000-0000-0000-000000000000' )
		--   
		Update A_Stat_Connections_1x1 --With ( TabLock )
		Set 
			ReasonStop = @reasonstop,
			StopSide = @stopside,
			TimeStop = @timestop
		Where
			Id = @id

	else
		--   IdChain
		Update A_Stat_Connections_1x1 --With ( TabLock )
		Set 
			ReasonStop = @reasonstop,
			StopSide = @stopside,
			TimeStop = @timestop
		Where
			IdChain = @idchain And
			Id = @id

end
GO




if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_Connection_Stop_GetById' ) )
	Drop procedure dbo.A_Stat_Connection_Stop_GetById
GO

Create Procedure dbo.A_Stat_Connection_Stop_GetById
	
	@id			uniqueidentifier,
	@reasonstop		int			OUTPUT,
	@stopside		int			OUTPUT,
	@timestop		datetime		OUTPUT,
	@idchain		uniqueidentifier	OUTPUT

as

begin
	
	Select 
		@reasonstop 	= ReasonStop,
		@stopside	= StopSide,
		@timestop	= TimeStop,
		@idchain	= IdChain
		
	From A_Stat_Connections_1x1 sc With ( NOLOCK )
	Where Id = @id
	
end
GO