
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerStreams' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerStreams' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'DialMode' )
	Alter Table dbo.A_ServerStreams
	Add DialMode int NULL
GO

Update A_ServerStreams
Set DialMode = 0
Where DialMode is NULL
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Admin_OfficeMap_ServerStream_Get' ))
	Drop procedure dbo.A_Admin_OfficeMap_ServerStream_Get
GO

Create procedure dbo.A_Admin_OfficeMap_ServerStream_Get
	@idserver uniqueidentifier
as
begin
	if ( @idserver = '00000000-0000-0000-0000-000000000000' )
		Select Id, Name, IdServer, Type, Account, RegType, GateId, DialMode
		From A_ServerStreams	
		Order By Name
	else
		Select Id, Name, IdServer, Type, Account, RegType, GateId, DialMode
		From A_ServerStreams
		Where IdServer = @idserver
		Order By Name
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Admin_OfficeMap_ServerStream_Set' ))
	Drop procedure dbo.A_Admin_OfficeMap_ServerStream_Set
GO

Create procedure dbo.A_Admin_OfficeMap_ServerStream_Set
	@id uniqueidentifier,
	@name nvarchar ( 500 ),
	@idserver uniqueidentifier,
	@type int,
	@account nvarchar ( 500 ) = '',
	@regtype int = 0,
	@gateid uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@dialmode int = 0
as
begin
	Insert into A_ServerStreams ( Id, Name, IdServer, Type, Account, RegType, GateId, DialMode )
	Values ( @id, @name, @idserver, @type, @account, @regtype, @gateid, @dialmode )
end
GO