if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_TaskManager_Lists' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_TaskManager_Lists' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'GetViewedFromTable' )
	Alter Table dbo.A_TaskManager_Lists
	Add GetViewedFromTable bit default 1
GO

Update A_TaskManager_Lists
Set GetViewedFromTable = 1
Where GetViewedFromTable is NULL
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_Save' ) )
	Drop procedure dbo.A_TaskManager_List_Save
GO

Create procedure [dbo].[A_TaskManager_List_Save]
	@id uniqueidentifier,	
	@name nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@idproject uniqueidentifier,
	@type int,
	@query nvarchar ( 1000 ),
	@joinedtable nvarchar ( 100 ),
	@getviewedfromtable bit = 1,
	@columnid nvarchar ( 100 ),
	@columnsphone nvarchar ( 1000 ),
	@columnname nvarchar ( 100 ),
	@columnsviewed nvarchar ( 1000 ),
	@columnsvieweddescription nvarchar ( 4000 ),
	@columnssqltype nvarchar ( 4000 ),
	@columnssqltypesize nvarchar ( 4000 )	
as
begin
	Declare @tp int
	Declare @jt nvarchar ( 100 )

	Select @tp = Type, @jt = JoinedTable
	From A_TaskManager_Lists 
	Where Id = @id

	declare @sql nvarchar ( 100 )
	set @sql = 'drop table ' + @jt

	--    ,    
	if ( @tp in ( 1, 5, 6 )) and ( @jt != @joinedtable )
		if ( exists ( Select * From sysobjects where id = object_id ( @jt ) ) )
			exec sp_executesql @sql

	Update A_Taskmanager_Lists
	Set		
		Name 			= @name,
		Description 		= @description,
		ProjectId 		= @idproject,
		Type 			= @type,
		Query 			= @query,
		JoinedTable 		= @joinedtable,
		GetViewedFromTable	= @getviewedfromtable,
		ColumnId 		= @columnid,
		ColumnsPhone 		= @columnsphone,
		ColumnName 		= @columnname,
		ColumnsViewed 		= @columnsviewed,
		ColumnsViewedDescription = @columnsvieweddescription,
		ColumnsSqlType 		= @columnssqltype,
		ColumnsSqlTypeSize 	= @columnssqltypesize
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert into A_TaskManager_Lists ( Id, Name, Description, ProjectId, Type, Query, JoinedTable, GetViewedFromTable, ColumnId, ColumnsPhone, ColumnName, ColumnsViewed, ColumnsViewedDescription, ColumnsSqlType, ColumnsSqlTypeSize )
		Values ( @id, @name, @description, @idproject, @type, @query, @joinedtable, @getviewedfromtable, @columnid, @columnsphone, @columnname, @columnsviewed, @columnsvieweddescription, @columnssqltype, @columnssqltypesize )
end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_List_GetInfo' ) )
	Drop procedure dbo.A_TaskManager_List_GetInfo
GO

Create procedure [dbo].[A_TaskManager_List_GetInfo]
	@id uniqueidentifier
as
begin

	Select Id, Name, Description, ProjectId, Type, 
		Query, JoinedTable, ColumnId, ColumnsPhone, 
		ColumnName, ColumnsViewed, ColumnsViewedDescription,
		ColumnsSqlType, ColumnsSqlTypeSize,
		GetViewedFromTable
	From A_TaskManager_Lists
	Where Id = @id or ProjectId = @id
	Order by Name
end
GO

