
if exists ( Select * From sysobjects Where id = object_id ( 'dbo.A_DB_CopyDataToSameTable' ) )
	Drop procedure dbo.A_DB_CopyDataToSameTable
GO

Create procedure dbo.A_DB_CopyDataToSameTable
	@srcsimplename nvarchar ( 500 ),
	@destdatabase nvarchar ( 500 ),
	@destsimplename nvarchar ( 500 )
as
begin
	Declare @srctablename nvarchar(500), @desttablename nvarchar(500)
	Set @srctablename = '[dbo].[' + @srcsimplename + ']'
	Set @desttablename = '[' + @destdatabase + '].[dbo].[' + @srcsimplename + ']'

 
   ------
   --     
   ------
	Declare @name nvarchar(500)
	Declare @columns nvarchar(4000)

	Set @columns = ''

	Declare crs Cursor LOCAL FAST_FORWARD For 
	   Select name 
	   From oktell_settings.dbo.syscolumns
	   Where id = object_id ( @desttablename )
	
	Open crs
	Fetch Next From crs Into @name

	While ( @@fetch_status = 0 ) begin
	   if ( @columns = '' )
	      Set @columns = '[' + @name + ']'
	   else
	      Set @columns = @columns + ', [' + @name + ']'

    	   Fetch Next From crs Into @name		
	end

   	Close crs
	Deallocate crs

   ------
   --  
   ------
	Declare @sqltext nvarchar(4000)
	Set @sqltext = '
		if exists ( select * from sysobjects where id = object_id ( ''' + @srctablename + ''' ) and OBJECTPROPERTY(id, N''IsUserTable'') = 1) 
		begin
 		   Declare @hasid bit
		   Set @hasid = 0

		   if exists ( select * from [' + @destdatabase + '].dbo.syscolumns where id = object_id ( ''' + @desttablename + ''' ) and status = 128 )
		      Set @hasid = 1

		   if ( @hasid = 1)
		      Set identity_insert ' + @desttablename + ' on

		   Insert Into ' + @desttablename + ' (' + @columns + ') 
	  	      select ' + @columns + ' from ' + @srctablename + ' 

		   if ( @hasid = 1)
		      Set identity_insert ' + @desttablename + ' off
		end '
	
	Exec sp_executesql @sqltext
end
GO