if exists ( select * from sysobjects where id = object_id ( 'dbo.A_VoiceMailReceivers' ) )
	Drop table [dbo].[A_VoiceMailReceivers]
GO

Create table dbo.A_VoiceMailReceivers
(	
	msgid uniqueidentifier,
	userid uniqueidentifier
)
GO



if exists ( select * from sysobjects where id = object_id ( 'dbo.A_VoiceMail_DeleteData' ) )
	Drop procedure [dbo].[A_VoiceMail_DeleteData]
GO

Create procedure [dbo].[A_VoiceMail_DeleteData]
	@id uniqueidentifier	
as
begin
	Delete From A_VoiceMail
	Where Id = @id

	Delete From A_VoiceMailReceivers
	Where msgid = @id
end
GO



if exists ( select * from sysobjects where id = object_id ( 'dbo.A_VoiceMail_GetDataForUser' ) )
	Drop procedure [dbo].[A_VoiceMail_GetDataForUser]
GO

Create procedure [dbo].[A_VoiceMail_GetDataForUser]
	@userid			uniqueidentifier,
	@onlynew		int,
	@topcount		int = -1
as
begin

/*
	Update A_VoiceMail
	Set RecievedTime = GetDate (),
		WhoRecieved = @userid	
	Where RecieverId = @userid
		and IsShown = 0;
*/

/*
	Declare @tmp table ( idx int identity ( 1, 1 ), Id uniqueidentifier, FilePath ntext, IsShown int, SentTime datetime, RecievedTime datetime, Info ntext, CallerId varchar(500), WhoRecieved uniqueidentifier, UName nvarchar(500) )

	Insert into @tmp
		Select vm.Id, FilePath, IsShown, SentTime, RecievedTime, vm.Info, CallerId, WhoRecieved, u.Name
		From A_VoiceMail vm
			left join A_Users u on vm.WhoRecieved = u.Id
		Where ( RecieverId = @userid )
			And (( IsShown = 0 ) or ( @onlynew = 0 ))
		Order By SentTime
*/

	Declare @tmp table ( idx int identity ( 1, 1 ), Id uniqueidentifier, SentTime datetime )

	Insert into @tmp
		Select vm.Id, SentTime
	    	From A_VoiceMail vm
			Left join A_VoiceMailReceivers vmr on vmr.MsgId = vm.id
	    	Where ((( vm.RecieverIsGroup = 0 ) And ( vm.RecieverId = @userid ))
				Or (( vm.RecieverIsGroup = 1 ) And ( vmr.UserId = @userid )))
			And (( IsShown = 0 ) or ( @onlynew = 0 ))
		Order by SentTime

/*
	    Select id, senttime
	    From 
	    ( 
		Select vm.Id, SentTime
	    	From A_VoiceMail vm
	    	Where ( RecieverIsGroup = 0 )
			And ( RecieverId = @userid )
			And (( IsShown = 0 ) or ( @onlynew = 0 ))

	    	Union all

	    	Select vm.Id, SentTime
	    	From A_VoiceMail vm
			Inner join A_VoiceMailReceivers vmr on vmr.MsgId = vm.id
	    	Where ( RecieverIsGroup = 1 )
			And ( vmr.UserId = @userid )
			And (( IsShown = 0 ) or ( @onlynew = 0 ))
	    ) a
	    Order By SentTime
*/
		

	if ( @topcount <= 0 ) begin

		Select vm.Id, vm.FilePath, vm.IsShown, vm.SentTime, vm.RecievedTime, vm.Info, vm.CallerId, vm.WhoRecieved, u.Name 
		From @tmp t
			Inner join A_VoiceMail vm on vm.id = t.id
			left join A_Users u on vm.WhoRecieved = u.Id

	end else begin

		Select vm.Id, vm.FilePath, vm.IsShown, vm.SentTime, vm.RecievedTime, vm.Info, vm.CallerId, vm.WhoRecieved, u.Name 
		From @tmp t
			Inner join A_VoiceMail vm on vm.id = t.id
			left join A_Users u on vm.WhoRecieved = u.Id
		Where t.idx <= @topcount

	end

/*
	if ( @topcount <= 0 )
		Select Id, FilePath, IsShown, SentTime, RecievedTime, Info, CallerId, WhoRecieved, UName 
		From @tmp
	else
		Select Id, FilePath, IsShown, SentTime, RecievedTime, Info, CallerId, WhoRecieved, UName 
		From @tmp 
		Where idx <= @topcount	
*/

/*
	Update A_VoiceMail
	Set IsShown = 1
	Where RecieverId = @userid
		and IsShown = 0;
*/
	
end
GO



if exists ( select * from sysobjects where id = object_id ( 'dbo.A_VoiceMail_CheckNewMail' ) )
	Drop procedure [dbo].[A_VoiceMail_CheckNewMail]
GO

Create procedure [dbo].[A_VoiceMail_CheckNewMail]
	@userid	uniqueidentifier,
	@found int OutPut
as
begin

	Select Id
	From A_VoiceMail vm
		Left join A_VoiceMailReceivers vmr on vmr.MsgId = vm.Id
	Where (( vm.RecieverId = @userid ) or ( vmr.UserId = @userid ))
		and ( IsShown = 0 )

	if ( @@rowcount > 0 )
		set @found = 1
	else
		set @found = 0
	
end
GO