if Exists ( select * FROM sysobjects where id=object_id ( 'dbo.A_Clients__GetFull_AllForUserFromGroup' ))
	Drop procedure dbo.A_Clients__GetFull_AllForUserFromGroup
GO

Create procedure [dbo].[A_Clients__GetFull_AllForUserFromGroup]
	@iduser		uniqueidentifier,
	@idgroup	uniqueidentifier
As
begin
	if ( @idgroup = '00000000-0000-0000-0000-000000000000' )
	begin
		Select *
		From A_Clients cl
			Left join A_ClientContacts cc on cl.Id = cc.IdClient			
		Where ( OwnerId = @iduser
			Or OwnerId = '00000000-0000-0000-0000-000000000000' )		
		Order by cl.id
	end
	else
	begin
		Select * 
		From A_Clients cl
			Inner join A_Clients_Groups clgr on cl.Id = clgr.IdClient
			Left join A_ClientContacts cc on cl.Id = cc.IdClient
		Where ( OwnerId = @iduser
			Or OwnerId = '00000000-0000-0000-0000-000000000000' )
			And clgr.IdGroup = @idgroup
		Order by cl.id
	end	
end
GO

